unit hiSQLite_info;

interface

uses Kol,Share,Debug;

type
  THISQLite_info = class(TDebug)
   private
    function Prepare(_db: pointer; _sql: String; var _pSt: Pointer): boolean;
   public
    _prop_Table:string;

    _data_Table:THI_Event;
    _data_dbHandle:THI_Event;
    _event_onColumns:THI_Event;    
    _event_onTblSize:THI_Event;
    _event_onError:THI_Event;

    procedure _work_doColumns(var _Data:TData; Index:word);
    procedure _work_doTblSize(var _Data:TData; Index:word);
  end;

implementation
uses SqLite3Api,hiSQLite_DB{, hiMT_Add};

function THISQLite_info.Prepare;
var pz:PChar;
begin
   result:= true;
   if sqlite3_prepare(_db, PChar(_sql), -1, _pSt, pz)=0 then exit;
   _hi_onEvent(_event_onError, sqlite3_errmsg(_db));
   result:=false;   
end; 

procedure THISQLite_info._work_doTblSize;
var dt, dtr: TData;
    db, pSt:pointer;
    i:integer;
    tbl:string;
begin
   dt := ReadData(_Data,_data_dbHandle,nil);
   if not _IsObject(dt,SQLite_GUID) then exit;
   db := ToObject(dt);
   tbl:= ReadString(_Data,_data_Table,_prop_Table);
   if Prepare(db,'select * from '+ tbl, pSt) then begin 
     dtInteger(dt,sqlite3_column_count(pSt));
     sqlite3_finalize(pSt);
     Prepare(db,'select count(*) from '+ tbl, pSt);
     sqlite3_step(pSt);
     dtInteger(dtr,sqlite3_column_int(pSt,0));
     dt.lData:=@dtr;
     //AddMTData(@dt,@_DoData(sqlite3_data_count(pSt)),s);
     _hi_onEvent(_event_onTblSize, dt);
     //freedata(@dt);
   end;
   sqlite3_finalize(pSt);
end;

procedure THISQLite_info._work_doColumns;
var dt,dt1,dt2,dt3:TData;
    db, pSt:pointer;
    i: integer;
    tbl: String;
begin
   dt := ReadData(_Data,_data_dbHandle,nil);
   if not _IsObject(dt,SQLite_GUID) then exit;
   db := ToObject(dt);
   tbl:=ReadString(_Data,_data_Table,_prop_Table);
   if Prepare(db,'select * from '+tbl, pSt) then 
     for i:=0 to sqlite3_column_count(pSt)-1 do begin
       dtString(dt,sqlite3_column_name(pSt, i));
       dtInteger(dt1,sqlite3_column_type(pSt, i));
       tbl:=sqlite3_column_decltype(pSt, i);
       dtString(dt2,parse(tbl,'('));
       dtInteger(dt3,str2int(parse(tbl,')')));
       dt.ldata:=@dt1; dt1.ldata:=@dt2; dt2.ldata:=@dt3;
       _hi_onEvent(_event_onColumns, dt);
     end;  
   sqlite3_finalize(pSt);
end;

end.
